# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution - module extension
#    Copyright (C) 2010- O4SB (<http://openforsmallbusiness.co.nz>).
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from tools.translate import _

class res_partner(osv.osv):
    _inherit = 'res.partner'
    
    _columns = {
        'store_ref': fields.char('Store Code', size=16, help='If the customer requires specific store references on documentation'),
        }
    
    def _check_store_code(self, cr, uid, ids, context=None):
        """This function checks that the store code is unique within the account hierarchy it belongs"""
        partner_obj = self.pool.get('res.partner')
        partner = partner_obj.browse(cr, uid, ids[0], context)
        if partner.store_ref:
            if partner.parent_id:
                group_partners = partner_obj.search(cr, uid, [('id', 'child_of', [partner.parent_id.id])])
            else:
                group_partners = partner_obj.search(cr, uid, [('id', 'child_of', [partner.id])])
            group_partners = list(set(group_partners) - set([ids[0]]))
            if group_partners:
                for p in partner_obj.browse(cr, uid, group_partners, context):
                    if p.store_ref and p.store_ref == partner.store_ref:
                        return False
        return True

    
    _constraints = [
        (_check_store_code, _('Store Codes must be unique per group'), ['store_ref']),
    ]
    
res_partner()
